#include "SimCal3.hxx"

using namespace gips;

const unsigned SPC_SIZE = 1024;
const unsigned IFG_SIZE = 2048;

typedef boost::array< double, SPC_SIZE > RealSpectrum;
typedef boost::array< std::complex< double >, IFG_SIZE > ComplexIfg;
 
typedef SimCal3< ComplexIfg, RealSpectrum, RealSpectrum> Pipeline;

int main()
{

    ComplexIfg obs;
    RealSpectrum calSpectrum;
    RealSpectrum outSpectrum;
    RealSpectrum outPhase;   
    RealSpectrum outResponsivity;
 
    Pipeline::ancillary_t anc;
    Pipeline::settings_t settings;
    Pipeline::ref_t ref;
    Pipeline::Ports ports;

    ports.ancillaryPtr = &anc;
    ports.refPtr = &ref;
    ports.obsPtr = &obs;
    ports.calSpectrumPtr = &calSpectrum;
    ports.outSpectrumPtr = &outSpectrum;
    ports.outPhasePtr = &outPhase;
    ports.outResponsivityPtr = &outResponsivity;
    
    Pipeline pipeline(settings, ports);

    pipeline();
    
}
